# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20171218
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re

from .base_enum_object import BaseEnumObject

# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class AppAuthType(BaseEnumObject):
    """
    Authentication type for an application.

    Enumeration values::
        AppAuthType.SECRET = "Secret"
        AppAuthType.CERTIFICATE = "Certificate"

    This class doesnt use python standard enumeration since they dont support unknown values. 
    
    This is an object of type BaseEnumObject and provides similar functionality as a String Enumeration.
    
    Get a standard instance of enum: AppAuthType.FOO or AppAuthType("FOO")
    Get non standard instance of enum: AppAuthType("BAR")
    Enum instance to String value: AppAuthType.FOO.value , AppAuthType.FOO.name (Gives "FOO")
    Equality: AppAuthType.FOO == AppAuthType("FOO") , AppAuthType.FOO != AppAuthType.BAR
    Provides str func:  str(AppAuthType.FOO) == "AppAuthType.FOO"
    
    Also the class maintains a static dict of values. hence AppAuthType.FOO and AppAuthType("FOO") are really backed by same data. 
    """
    
    """
    Inner class that stores the actual value
    """
    class __AppAuthType(BaseEnumObject):

        def __init__(self, value):
            self.__value = value

        @property
        def value(self):
            return self.__value

        @property
        def name(self):
            return self.__value

        def __str__(self):
            return "AppAuthType." + self.__value

    """
    allowed enum values
    """
    SECRET = __AppAuthType("Secret")
    CERTIFICATE = __AppAuthType("Certificate")

    """
    dictionary that keeps the enum value mapping for static access
    """
    __VALUES = dict()
    __VALUES["Secret"] = SECRET
    __VALUES["Certificate"] = CERTIFICATE

    def __init__(self, name):
        if name in AppAuthType.__VALUES:
            self.__instance = AppAuthType.__VALUES[name]
        else:
            new_value = AppAuthType.__AppAuthType(name)
            AppAuthType.__VALUES[name] = new_value
            self.__instance = new_value

    @property
    def value(self):
        return self.__instance.value

    @property
    def name(self):
        return self.__instance.name

    def __str__(self):
        return "AppAuthType." + self.__instance.name

    """ 
    This is to ensure equals work for both static defined values and client defined ones.
    """
    def __eq__(self, other):
        if (isinstance(self, AppAuthType) or isinstance(self, AppAuthType.__AppAuthType)) and \
                (isinstance(other, AppAuthType) or isinstance(other, AppAuthType.__AppAuthType)):
                return self.value == other.value

        return False

    def __ne__(self, other):
        if (isinstance(self, AppAuthType) or isinstance(self, AppAuthType.__AppAuthType)) and \
                (isinstance(other, AppAuthType) or isinstance(other, AppAuthType.__AppAuthType)):
                return self.value != other.value

        return True



