# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20171218
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re

from .base_enum_object import BaseEnumObject

# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class ObjectOrigin(BaseEnumObject):
    """
    Where this security object originated.

    Enumeration values::
        ObjectOrigin.FORTANIXHSM = "FortanixHSM"
        ObjectOrigin.EXTERNAL = "External"

    This class doesnt use python standard enumeration since they dont support unknown values. 
    
    This is an object of type BaseEnumObject and provides similar functionality as a String Enumeration.
    
    Get a standard instance of enum: ObjectOrigin.FOO or ObjectOrigin("FOO")
    Get non standard instance of enum: ObjectOrigin("BAR")
    Enum instance to String value: ObjectOrigin.FOO.value , ObjectOrigin.FOO.name (Gives "FOO")
    Equality: ObjectOrigin.FOO == ObjectOrigin("FOO") , ObjectOrigin.FOO != ObjectOrigin.BAR
    Provides str func:  str(ObjectOrigin.FOO) == "ObjectOrigin.FOO"
    
    Also the class maintains a static dict of values. hence ObjectOrigin.FOO and ObjectOrigin("FOO") are really backed by same data. 
    """
    
    """
    Inner class that stores the actual value
    """
    class __ObjectOrigin(BaseEnumObject):

        def __init__(self, value):
            self.__value = value

        @property
        def value(self):
            return self.__value

        @property
        def name(self):
            return self.__value

        def __str__(self):
            return "ObjectOrigin." + self.__value

    """
    allowed enum values
    """
    FORTANIXHSM = __ObjectOrigin("FortanixHSM")
    EXTERNAL = __ObjectOrigin("External")

    """
    dictionary that keeps the enum value mapping for static access
    """
    __VALUES = dict()
    __VALUES["FortanixHSM"] = FORTANIXHSM
    __VALUES["External"] = EXTERNAL

    def __init__(self, name):
        if name in ObjectOrigin.__VALUES:
            self.__instance = ObjectOrigin.__VALUES[name]
        else:
            new_value = ObjectOrigin.__ObjectOrigin(name)
            ObjectOrigin.__VALUES[name] = new_value
            self.__instance = new_value

    @property
    def value(self):
        return self.__instance.value

    @property
    def name(self):
        return self.__instance.name

    def __str__(self):
        return "ObjectOrigin." + self.__instance.name

    """ 
    This is to ensure equals work for both static defined values and client defined ones.
    """
    def __eq__(self, other):
        if (isinstance(self, ObjectOrigin) or isinstance(self, ObjectOrigin.__ObjectOrigin)) and \
                (isinstance(other, ObjectOrigin) or isinstance(other, ObjectOrigin.__ObjectOrigin)):
                return self.value == other.value

        return False

    def __ne__(self, other):
        if (isinstance(self, ObjectOrigin) or isinstance(self, ObjectOrigin.__ObjectOrigin)) and \
                (isinstance(other, ObjectOrigin) or isinstance(other, ObjectOrigin.__ObjectOrigin)):
                return self.value != other.value

        return True



