# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20171218
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re



# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class SignRequest(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'hash_alg': 'DigestAlgorithm',
        'hash': 'bytearray'
    }

    attribute_map = {
        'hash_alg': 'hash_alg',
        'hash': 'hash'
    }

    def __init__(self, hash_alg=None, hash=None):
        """
        SignRequest - a model defined in Swagger
        """

        self._hash_alg = None
        self._hash = None

        self.hash_alg = hash_alg
        self.hash = hash

    @property
    def hash_alg(self):
        """
        Gets the hash_alg of this SignRequest.

        Type: L{DigestAlgorithm}
        """
        return self._hash_alg

    @hash_alg.setter
    def hash_alg(self, hash_alg):
        """
        Sets the hash_alg of this SignRequest.
        """
        if hash_alg is None:
            raise ValueError("Invalid value for `hash_alg`, must not be `None`")

        self._hash_alg = hash_alg

    @property
    def hash(self):
        """
        Gets the hash of this SignRequest.
        Hash of the data to be signed.

        Type: L{bytearray}
        """
        return self._hash

    @hash.setter
    def hash(self, hash):
        """
        Sets the hash of this SignRequest.
        Hash of the data to be signed.
        """
        if hash is None:
            raise ValueError("Invalid value for `hash`, must not be `None`")

        if not isinstance(hash, bytearray):
            raise ValueError("Invalid value for `hash`, `hash` must be a bytearray")
        self._hash = hash

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, SignRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

