# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20171218
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re



# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class SobjectRequest(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'key_size': 'int',
        'elliptic_curve': 'EllipticCurve',
        'group_id': 'str',
        'obj_type': 'ObjectType',
        'attributes': 'KeyAttributes',
        'key_ops': 'list[KeyOperations]',
        'custom_metadata': 'dict(str, str)',
        'value': 'bytearray',
        'enabled': 'bool',
        'transient': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'key_size': 'key_size',
        'elliptic_curve': 'elliptic_curve',
        'group_id': 'group_id',
        'obj_type': 'obj_type',
        'attributes': 'attributes',
        'key_ops': 'key_ops',
        'custom_metadata': 'custom_metadata',
        'value': 'value',
        'enabled': 'enabled',
        'transient': 'transient'
    }

    def __init__(self, name=None, description=None, key_size=None, elliptic_curve=None, group_id=None, obj_type=None, attributes=None, key_ops=None, custom_metadata=None, value=None, enabled=None, transient=None):
        """
        SobjectRequest - a model defined in Swagger
        """

        self._name = None
        self._description = None
        self._key_size = None
        self._elliptic_curve = None
        self._group_id = None
        self._obj_type = None
        self._attributes = None
        self._key_ops = None
        self._custom_metadata = None
        self._value = None
        self._enabled = None
        self._transient = None

        self.name = name
        if description is not None:
          self.description = description
        if key_size is not None:
          self.key_size = key_size
        if elliptic_curve is not None:
          self.elliptic_curve = elliptic_curve
        if group_id is not None:
          self.group_id = group_id
        self.obj_type = obj_type
        if attributes is not None:
          self.attributes = attributes
        if key_ops is not None:
          self.key_ops = key_ops
        if custom_metadata is not None:
          self.custom_metadata = custom_metadata
        if value is not None:
          self.value = value
        if enabled is not None:
          self.enabled = enabled
        if transient is not None:
          self.transient = transient

    @property
    def name(self):
        """
        Gets the name of this SobjectRequest.
        Name of the security object to create or import. Security object names must be unique within an account.

        Type: L{str}
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this SobjectRequest.
        Name of the security object to create or import. Security object names must be unique within an account.
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def description(self):
        """
        Gets the description of this SobjectRequest.
        Description of the security object to create or import.

        Type: L{str}
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this SobjectRequest.
        Description of the security object to create or import.
        """

        self._description = description

    @property
    def key_size(self):
        """
        Gets the key_size of this SobjectRequest.
        Size in bits (not bytes) of the security object to create or import. Required for all objects not of type EC.

        Type: L{int}
        """
        return self._key_size

    @key_size.setter
    def key_size(self, key_size):
        """
        Sets the key_size of this SobjectRequest.
        Size in bits (not bytes) of the security object to create or import. Required for all objects not of type EC.
        """

        self._key_size = key_size

    @property
    def elliptic_curve(self):
        """
        Gets the elliptic_curve of this SobjectRequest.

        Type: L{EllipticCurve}
        """
        return self._elliptic_curve

    @elliptic_curve.setter
    def elliptic_curve(self, elliptic_curve):
        """
        Sets the elliptic_curve of this SobjectRequest.
        """

        self._elliptic_curve = elliptic_curve

    @property
    def group_id(self):
        """
        Gets the group_id of this SobjectRequest.
        Group ID (not name) of the security group that this security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used. 

        Type: L{str}
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id):
        """
        Sets the group_id of this SobjectRequest.
        Group ID (not name) of the security group that this security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used. 
        """

        self._group_id = group_id

    @property
    def obj_type(self):
        """
        Gets the obj_type of this SobjectRequest.

        Type: L{ObjectType}
        """
        return self._obj_type

    @obj_type.setter
    def obj_type(self, obj_type):
        """
        Sets the obj_type of this SobjectRequest.
        """
        if obj_type is None:
            raise ValueError("Invalid value for `obj_type`, must not be `None`")

        self._obj_type = obj_type

    @property
    def attributes(self):
        """
        Gets the attributes of this SobjectRequest.

        Type: L{KeyAttributes}
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """
        Sets the attributes of this SobjectRequest.
        """

        self._attributes = attributes

    @property
    def key_ops(self):
        """
        Gets the key_ops of this SobjectRequest.
        Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled. 

        Type: list[L{KeyOperations}]
        """
        return self._key_ops

    @key_ops.setter
    def key_ops(self, key_ops):
        """
        Sets the key_ops of this SobjectRequest.
        Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled. 
        """

        self._key_ops = key_ops

    @property
    def custom_metadata(self):
        """
        Gets the custom_metadata of this SobjectRequest.
        User-defined metadata for this key. Stored as key-value pairs.

        Type: map[L{str}]
        """
        return self._custom_metadata

    @custom_metadata.setter
    def custom_metadata(self, custom_metadata):
        """
        Sets the custom_metadata of this SobjectRequest.
        User-defined metadata for this key. Stored as key-value pairs.
        """

        self._custom_metadata = custom_metadata

    @property
    def value(self):
        """
        Gets the value of this SobjectRequest.
        When importing a security object, this field contains the binary contents to import. When creating a security object, this field is unused. 

        Type: L{bytearray}
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Sets the value of this SobjectRequest.
        When importing a security object, this field contains the binary contents to import. When creating a security object, this field is unused. 
        """

        if not isinstance(value, bytearray):
            raise ValueError("Invalid value for `value`, `value` must be a bytearray")
        self._value = value

    @property
    def enabled(self):
        """
        Gets the enabled of this SobjectRequest.
        Whether the new security object should be enabled. Disabled security objects may not perform cryptographic operations. 

        Type: L{bool}
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """
        Sets the enabled of this SobjectRequest.
        Whether the new security object should be enabled. Disabled security objects may not perform cryptographic operations. 
        """

        self._enabled = enabled

    @property
    def transient(self):
        """
        Gets the transient of this SobjectRequest.
        If this is true, SDKMS will create a transient key.

        Type: L{bool}
        """
        return self._transient

    @transient.setter
    def transient(self, transient):
        """
        Sets the transient of this SobjectRequest.
        If this is true, SDKMS will create a transient key.
        """

        self._transient = transient

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, SobjectRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

