# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20171218
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re

from .base_enum_object import BaseEnumObject

# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class SubscriptionType(BaseEnumObject):
    """
    Type of Subscription.

    Enumeration values::
        SubscriptionType.TRIAL = "Trial"
        SubscriptionType.ENTERPRISE = "Enterprise"
        SubscriptionType.PREMIUM = "Premium"

    This class doesnt use python standard enumeration since they dont support unknown values. 
    
    This is an object of type BaseEnumObject and provides similar functionality as a String Enumeration.
    
    Get a standard instance of enum: SubscriptionType.FOO or SubscriptionType("FOO")
    Get non standard instance of enum: SubscriptionType("BAR")
    Enum instance to String value: SubscriptionType.FOO.value , SubscriptionType.FOO.name (Gives "FOO")
    Equality: SubscriptionType.FOO == SubscriptionType("FOO") , SubscriptionType.FOO != SubscriptionType.BAR
    Provides str func:  str(SubscriptionType.FOO) == "SubscriptionType.FOO"
    
    Also the class maintains a static dict of values. hence SubscriptionType.FOO and SubscriptionType("FOO") are really backed by same data. 
    """
    
    """
    Inner class that stores the actual value
    """
    class __SubscriptionType(BaseEnumObject):

        def __init__(self, value):
            self.__value = value

        @property
        def value(self):
            return self.__value

        @property
        def name(self):
            return self.__value

        def __str__(self):
            return "SubscriptionType." + self.__value

    """
    allowed enum values
    """
    TRIAL = __SubscriptionType("Trial")
    ENTERPRISE = __SubscriptionType("Enterprise")
    PREMIUM = __SubscriptionType("Premium")

    """
    dictionary that keeps the enum value mapping for static access
    """
    __VALUES = dict()
    __VALUES["Trial"] = TRIAL
    __VALUES["Enterprise"] = ENTERPRISE
    __VALUES["Premium"] = PREMIUM

    def __init__(self, name):
        if name in SubscriptionType.__VALUES:
            self.__instance = SubscriptionType.__VALUES[name]
        else:
            new_value = SubscriptionType.__SubscriptionType(name)
            SubscriptionType.__VALUES[name] = new_value
            self.__instance = new_value

    @property
    def value(self):
        return self.__instance.value

    @property
    def name(self):
        return self.__instance.name

    def __str__(self):
        return "SubscriptionType." + self.__instance.name

    """ 
    This is to ensure equals work for both static defined values and client defined ones.
    """
    def __eq__(self, other):
        if (isinstance(self, SubscriptionType) or isinstance(self, SubscriptionType.__SubscriptionType)) and \
                (isinstance(other, SubscriptionType) or isinstance(other, SubscriptionType.__SubscriptionType)):
                return self.value == other.value

        return False

    def __ne__(self, other):
        if (isinstance(self, SubscriptionType) or isinstance(self, SubscriptionType.__SubscriptionType)) and \
                (isinstance(other, SubscriptionType) or isinstance(other, SubscriptionType.__SubscriptionType)):
                return self.value != other.value

        return True



